### Method

# EDataServer MsOapxbc acquire_prt_sso_cookie_sync

since: 3.54

#### Declaration [src]

    SoupCookie*
    e_ms_oapxbc_acquire_prt_sso_cookie_sync (
      EMsOapxbc* self,
      JsonObject* account,
      const gchar* sso_url,
      JsonArray* scopes,
      const gchar* redirect_uri,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Synchronously calls acquirePrtSsoCookie() D-Bus method on the Microsoft OAuth2 broker service and converts the result into a new `SoupCookie`. The account object needs to be taken from the accounts list that is returned by e_ms_oapxbc_get_accounts_sync(). The SSO URL is the OAuth2 authentication endpoint. The scopes are the requested scopes for the OAuth2 service (usually only https://graph.microsoft.com/.default). The redirect URI is the OAuth2 service redirect URI.

Available since: 3.54

#### Parameters

`account`

  Type: `JsonObject`

  An account returned from e_ms_oapxbc_get_accounts_sync().

  The data is owned by the caller of the method.

`sso_url`

  Type: `const gchar*`

  An SSO URL to acquire the PRT SSO cookie for.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`scopes`

  Type: `JsonArray`

  Array of scopes.

  The data is owned by the caller of the method.

`redirect_uri`

  Type: `const gchar*`

  Redirect URI.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`cancellable`

  Type: `GCancellable`

  A `GCancellable`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `SoupCookie`

An acquired cookie, or `NULL` on error.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.
The return value can be `NULL`.